#!/bin/bash

stringContains() {
    if [[ $2 == *"$1"* ]]; then
      return 0
    else
        return 1
    fi
}

isPackageInstalled() {
    local status_info=$(dpkg -s "$1" 2>/dev/null | grep -wi "status:")
    local _lc=${status_info,,}
    if stringContains "status: install ok" "$_lc" ; then
        return 0
    else
        return 1
    fi
}

base_dir=$( dirname "${BASH_SOURCE[0]}" )

# В системе должны быть установлены пакеты
# gzip, pcsc-lite-ccid, gcr, libxcb-xinerama0

JCPKCS_PACKAGE=`ls -l "$(dirname "$0")" | sed -r -n 's/.*(jcpkcs11-2_[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+_x64\.deb)/\1/p'`
UC_PACKAGE=`ls -l "$(dirname "$0")" | sed -r -n 's/.*(jacartauc_[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+_x64_ru\.deb)/\1/p'`
JCSECURBIO_PACKAGE=`ls -l "$(dirname "$0")" | sed -r -n 's/.*(jcsecurbio_[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+_x64\.deb)/\1/p'`

if [ -z "${base_dir}/$JCPKCS_PACKAGE" ]; then
    echo "Ошибка!!! Отсутствует пакет jcpkcs11-2!"
    exit 1
fi

if [ -z "${base_dir}/$UC_PACKAGE" ]; then
    echo "Ошибка!!! Отсутствует пакет jacartauc!"
    exit 1
fi

if [ -z "${base_dir}/$JCSECURBIO_PACKAGE" ]; then
    echo "Ошибка!!! Отсутствует пакет jcsesurbio!"
    exit 1
fi

if ! isPackageInstalled libc6 ; then 
    echo "Ошибка!!! Не установлен пакет libc6!"
    exit 1
fi

if ! isPackageInstalled libccid ; then 
#   Устанавливаем пакет libccid
    apt-get install -y libccid
fi

if ! isPackageInstalled pcscd ; then 
#   Устанавливаем пакет pcscd
    apt-get install -y pcscd
fi

echo "Установка пакетов!"
echo "=========================================="
apt-get install -y "${base_dir}/$JCPKCS_PACKAGE" "${base_dir}/$UC_PACKAGE" "${base_dir}/$JCSECURBIO_PACKAGE"